scoreboard players enable @a ss.sell
scoreboard players enable @a ss.cancel
scoreboard players enable @a ss.align
scoreboard players enable @a ss.sellall
scoreboard players enable @a ss.cancelall

execute as @a[scores={ss.sellall=1..65}] at @s if entity @e[type=item,limit=1,sort=nearest,tag=!forSale,distance=..5] run scoreboard players operation @s ss.sell = @s ss.sellall
execute as @a[scores={ss.sellall=1..65}] at @s unless entity @e[type=item,limit=1,sort=nearest,tag=!forSale,distance=..5] run scoreboard players set @s ss.sellall 0

execute as @a[scores={ss.cancelall=1..}] at @s if entity @e[type=item,limit=1,sort=nearest,tag=forSale,distance=..5] run scoreboard players operation @s ss.cancel = @s ss.cancelall
execute as @a[scores={ss.cancelall=1..}] at @s unless entity @e[type=item,limit=1,sort=nearest,tag=forSale,distance=..5] run scoreboard players set @s ss.cancelall 0

execute as @a[scores={ss.sell=1..65},tag=autoAlign] at @s at @e[type=item,limit=1,sort=nearest,tag=!forSale,distance=..5] align xyz run tp @e[type=item,limit=1,sort=nearest,tag=!forSale,distance=..5] ~0.5 ~ ~0.5
execute as @a[scores={ss.sell=1..65}] at @s at @e[type=item,limit=1,sort=nearest,tag=!forSale,distance=..5] unless entity @e[tag=forSale,distance=..0.7] run data merge entity @e[type=item,limit=1,sort=nearest,tag=!forSale,distance=..5] {Age:-32768,PickupDelay:32767,Invulnerable:1b,NoGravity:1b,Motion:[0.0,0.0,0.0]}
execute as @a[scores={ss.sell=1..65}] at @s at @e[type=item,limit=1,sort=nearest,tag=!forSale,distance=..5] unless entity @e[tag=forSale,distance=..0.7] run scoreboard players operation @e[type=item,limit=1,sort=nearest,tag=!forSale,distance=..5] sellValue = @s ss.sell
execute as @a[scores={ss.sell=1..65}] at @s at @e[type=item,limit=1,sort=nearest,tag=!forSale,distance=..5] unless entity @e[tag=forSale,distance=..0.7] run scoreboard players operation @e[type=item,limit=1,sort=nearest,tag=!forSale,distance=..5] ss.playerid = @s ss.playerid
execute as @a[scores={ss.sell=1..64}] at @s at @e[type=item,limit=1,sort=nearest,tag=!forSale,distance=..5] unless entity @e[tag=forSale,distance=..0.7 ] if entity @e[type=item,limit=1,sort=nearest,tag=!forSale,distance=..5] run tellraw @s ["",{"text":"Successfully started selling","color":"gray"},{"text":" "},{"selector":"@e[type=item,limit=1,sort=nearest,tag=!forSale,distance=..5]","color":"#708090"}]
execute as @a[scores={ss.sell=65}] at @s at @e[type=item,limit=1,sort=nearest,tag=!forSale,distance=..5] unless entity @e[tag=forSale,distance=..0.7] if entity @e[type=item,limit=1,sort=nearest,tag=!forSale,distance=..5] run tellraw @s ["",{"text":"Successfully started displaying","color":"gray"},{"text":" "},{"selector":"@e[type=item,limit=1,sort=nearest,tag=!forSale,distance=..5]","color":"#708090"}]
execute as @a[scores={ss.sell=1..65}] at @s at @e[type=item,limit=1,sort=nearest,tag=!forSale,distance=..5] unless entity @e[tag=forSale,distance=..0.7] if entity @e[type=item,limit=1,sort=nearest,tag=!forSale,distance=..5] run playsound block.note_block.pling block @s ~ ~ ~ 0.5 2 
execute as @a[scores={ss.sell=1..65}] at @s at @e[type=item,limit=1,sort=nearest,tag=!forSale,distance=..5] unless entity @e[tag=forSale,distance=..0.7] run tag @e[type=item,limit=1,sort=nearest,tag=!forSale,tag=!forSale,distance=..5] add forSale
scoreboard players set @a ss.sell 0

execute as @a[scores={ss.cancel=1..}] at @s if score @s ss.playerid = @e[type=item,limit=1,sort=nearest,tag=forSale,distance=..5] ss.playerid run data merge entity @e[type=item,limit=1,sort=nearest,tag=forSale,distance=..5] {Age:0,PickupDelay:20,Invulnerable:0b,NoGravity:0b}
execute as @a[scores={ss.cancel=1..}] at @s if score @s ss.playerid = @e[type=item,limit=1,sort=nearest,tag=forSale,distance=..5,scores={sellValue=1..64}] ss.playerid run tellraw @s ["",{"text":"Successfully stopped selling","color":"gray"},{"text":" "},{"selector":"@e[type=item,limit=1,sort=nearest,tag=forSale,distance=..5]","color":"#708090"}]
execute as @a[scores={ss.cancel=1..}] at @s if score @s ss.playerid = @e[type=item,limit=1,sort=nearest,tag=forSale,distance=..5,scores={sellValue=65}] ss.playerid run tellraw @s ["",{"text":"Successfully stopped displaying","color":"gray"},{"text":" "},{"selector":"@e[type=item,limit=1,sort=nearest,tag=forSale,distance=..5]","color":"#708090"}]
execute as @a[scores={ss.cancel=1..}] at @s if score @s ss.playerid = @e[type=item,limit=1,sort=nearest,tag=forSale,distance=..5] ss.playerid if entity @e[type=block_display,limit=1,sort=nearest,tag=glassCase,distance=..5] at @e[type=block_display,limit=1,sort=nearest,tag=glassCase,distance=..5] run summon item ~0.375 ~ ~0.375 {Item:{Count:1b,id:"minecraft:glass"}}
execute as @a[scores={ss.cancel=1..}] at @s if score @s ss.playerid = @e[type=item,limit=1,sort=nearest,tag=forSale,distance=..5] ss.playerid if entity @e[type=block_display,limit=1,sort=nearest,tag=glassCase,distance=..5] at @e[type=block_display,limit=1,sort=nearest,tag=glassCase,distance=..5] run particle block glass ~0.375 ~0.375 ~0.375 0.15 0.15 0.15 0 20
execute as @a[scores={ss.cancel=1..}] at @s if score @s ss.playerid = @e[type=item,limit=1,sort=nearest,tag=forSale,distance=..5] ss.playerid if entity @e[type=block_display,limit=1,sort=nearest,tag=glassCase,distance=..5] at @e[type=block_display,limit=1,sort=nearest,tag=glassCase,distance=..5] run playsound block.glass.break block @s ~ ~ ~ 0.5 1
execute as @a[scores={ss.cancel=1..}] at @s if score @s ss.playerid = @e[type=item,limit=1,sort=nearest,tag=forSale,distance=..5] ss.playerid if entity @e[type=block_display,limit=1,sort=nearest,tag=glassCase,distance=..5] at @e[type=block_display,limit=1,sort=nearest,tag=glassCase,distance=..5] run kill @e[type=block_display,limit=1,sort=nearest,tag=glassCase,distance=..5]
execute as @a[scores={ss.cancel=1..}] at @s if score @s ss.playerid = @e[type=item,limit=1,sort=nearest,tag=forSale,distance=..5] ss.playerid run tag @e[type=item,limit=1,sort=nearest,tag=forSale,distance=..5] remove forSale
scoreboard players set @a ss.cancel 0

execute as @a[scores={ss.align=1},tag=autoAlign] run tellraw @s [{"text":"Successfully disabled Auto-Align. ","color":"gray"},{"text":"/trigger ss.align set -1","color":"#708090"},{"text":" to enable!","color":"gray"}]
execute as @a[scores={ss.align=1},tag=autoAlign] run tag @s remove autoAlign
execute as @a[scores={ss.align=1..}] at @s if score @s ss.playerid = @e[type=item,limit=1,sort=nearest,tag=forSale,distance=..5] ss.playerid at @e[type=item,limit=1,sort=nearest,tag=forSale,distance=..5] align xyz run tp @e[type=item,limit=1,sort=nearest,tag=forSale,distance=..5] ~0.5 ~ ~0.5
execute as @a[scores={ss.align=-1},tag=!autoAlign] run tag @s add autoAlign
execute as @a[scores={ss.align=-1},tag=autoAlign] run tellraw @s [{"text":"Successfully enabled Auto-Align. ","color":"gray"},{"text":"/trigger ss.align","color":"#708090"},{"text":" to disable!","color":"gray"}]
scoreboard players set @a ss.align 0

execute as @e[tag=forSale,scores={sellValue=1..64}] at @s if entity @e[distance=..0.3,nbt={Item:{id:"minecraft:diamond"}}] store result score @s buyValue run data get entity @e[distance=..1,limit=1,sort=nearest,nbt={Item:{id:"minecraft:diamond"}}] Item.Count
execute as @e[tag=forSale,scores={sellValue=1..64}] at @s if score @s buyValue = @s sellValue run data modify entity @e[distance=..1,limit=1,sort=nearest,nbt={Item:{id:"minecraft:diamond"}}] Owner set from entity @s Thrower
execute as @e[tag=forSale,scores={sellValue=1..64}] at @s if score @s buyValue = @s sellValue run tp @e[distance=..1,limit=1,sort=nearest,nbt={Item:{id:"minecraft:diamond"}}] ~ ~ ~
execute as @e[tag=forSale,scores={sellValue=1..64}] at @s if score @s buyValue = @s sellValue run data merge entity @e[distance=..1,limit=1,sort=nearest,nbt={Item:{id:"minecraft:diamond"}}] {Motion:[0.0,0.0,0.0],Age:-32768,Invulnerable:1b,NoGravity:1b,Tags:["bought"]}
execute as @e[tag=forSale,scores={sellValue=1..64}] at @s if score @s buyValue = @s sellValue if entity @e[type=block_display,limit=1,sort=nearest,tag=glassCase,distance=..1] run particle block glass ~0.375 ~0.375 ~0.375 0.15 0.15 0.15 0 20
execute as @e[tag=forSale,scores={sellValue=1..64}] at @s if score @s buyValue = @s sellValue if entity @e[type=block_display,limit=1,sort=nearest,tag=glassCase,distance=..1] run kill @e[type=block_display,limit=1,sort=nearest,tag=glassCase,distance=..1]
execute as @e[tag=forSale,scores={sellValue=1}] at @s if score @s buyValue = @s sellValue unless score RP gamerule matches 1 run tellraw @p ["",{"text":"Successfully bought ","color":"gray"},{"score":{"name":"@e[type=item,limit=1,sort=nearest,tag=forSale,distance=..3]","objective":"count"},"color":"#708090"},{"text":"x ","color":"#708090"},{"selector":"@e[type=item,limit=1,sort=nearest,tag=forSale,distance=..5]","color":"#708090"},{"text":" for ","color":"gray"},{"score":{"name":"@s","objective":"sellValue"},"color":"#708090"},{"text":" diamond.","color":"gray"}]
execute as @e[tag=forSale,scores={sellValue=2..64}] at @s if score @s buyValue = @s sellValue unless score RP gamerule matches 1 run tellraw @p ["",{"text":"Successfully bought ","color":"gray"},{"score":{"name":"@e[type=item,limit=1,sort=nearest,tag=forSale,distance=..3]","objective":"count"},"color":"#708090"},{"text":"x ","color":"#708090"},{"selector":"@e[type=item,limit=1,sort=nearest,tag=forSale,distance=..5]","color":"#708090"},{"text":" for ","color":"gray"},{"score":{"name":"@s","objective":"sellValue"},"color":"#708090"},{"text":" diamonds.","color":"gray"}]
execute as @e[tag=forSale,scores={sellValue=1..64}] at @s if score @s buyValue = @s sellValue if score RP gamerule matches 1 run tellraw @p ["",{"text":"Successfully bought ","color":"gray"},{"score":{"name":"@e[type=item,limit=1,sort=nearest,tag=forSale,distance=..3]","objective":"count"},"color":"#708090"},{"text":"x ","color":"#708090"},{"selector":"@e[type=item,limit=1,sort=nearest,tag=forSale,distance=..5]","color":"#708090"},{"text":" for ","color":"gray"},{"score":{"name":"@s","objective":"sellValue"},"color":"#708090"},{"text":"\u0001.","color":"white"}]
execute as @e[tag=forSale,scores={sellValue=1..64}] at @s if score @s buyValue = @s sellValue run playsound entity.item.pickup block @p ~ ~ ~ 0.5 2
execute as @e[tag=forSale,scores={sellValue=1..64}] at @s if score @s buyValue = @s sellValue run particle minecraft:poof ~ ~1 ~ 0.1 0.1 0.1 0 20
execute as @e[tag=forSale,scores={sellValue=1..64}] at @s if score @s buyValue = @s sellValue run data merge entity @s {Age:0,PickupDelay:20,Invulnerable:0b,NoGravity:0b}
execute as @e[tag=forSale,scores={sellValue=1..64}] at @s if score @s buyValue = @s sellValue run tag @s remove forSale

execute as @e[tag=forSale] at @s store result score @s count run data get entity @s Item.Count

execute as @a at @s store result score @s ss.diamondcount run clear @s diamond 0

execute as @a at @s if entity @e[distance=..3,tag=forSale,scores={sellValue=1}] unless score RP gamerule matches 1 run title @s actionbar ["",{"text":"Buy? ","color":"gray"},{"score":{"name":"@e[type=item,limit=1,sort=nearest,tag=forSale,distance=..3]","objective":"count"},"color":"white"},{"text":"x ","color":"white"},{"selector":"@e[type=item,limit=1,sort=nearest,tag=forSale,distance=..3]"},{"text":" for ","color":"gray"},{"score":{"name":"@e[type=item,limit=1,sort=nearest,tag=forSale,distance=..3]","objective":"sellValue"},"color":"white"},{"text":" diamond.","color":"gray"}]
execute as @a at @s if entity @e[distance=..3,tag=forSale,scores={sellValue=2..64}] unless score RP gamerule matches 1 run title @s actionbar ["",{"text":"Buy? ","color":"gray"},{"score":{"name":"@e[type=item,limit=1,sort=nearest,tag=forSale,distance=..3]","objective":"count"},"color":"white"},{"text":"x ","color":"white"},{"selector":"@e[type=item,limit=1,sort=nearest,tag=forSale,distance=..3]"},{"text":" for ","color":"gray"},{"score":{"name":"@e[type=item,limit=1,sort=nearest,tag=forSale,distance=..3]","objective":"sellValue"},"color":"white"},{"text":" diamonds.","color":"gray"}]
execute as @a at @s if entity @e[distance=..3,tag=forSale,scores={sellValue=1..64}] if score @s ss.diamondcount < @e[distance=..3,tag=forSale,scores={sellValue=1..64},limit=1,sort=nearest] sellValue if score RP gamerule matches 1 run title @s actionbar ["",{"text":"Buy? ","color":"gray"},{"score":{"name":"@e[type=item,limit=1,sort=nearest,tag=forSale,distance=..3]","objective":"count"},"color":"white"},{"text":"x ","color":"white"},{"selector":"@e[type=item,limit=1,sort=nearest,tag=forSale,distance=..3]"},{"text":" for ","color":"gray"},{"score":{"name":"@e[type=item,limit=1,sort=nearest,tag=forSale,distance=..3]","objective":"sellValue"},"color":"white"},{"text":"\u0001","color":"white"},{"text":" You have: ","color":"gray"},{"score":{"name":"@s","objective":"ss.diamondcount"},"color":"red"},{"text":"\u0001","color":"white"}]
execute as @a at @s if entity @e[distance=..3,tag=forSale,scores={sellValue=1..64}] if score @s ss.diamondcount >= @e[distance=..3,tag=forSale,scores={sellValue=1..64},limit=1,sort=nearest] sellValue if score RP gamerule matches 1 run title @s actionbar ["",{"text":"Buy? ","color":"gray"},{"score":{"name":"@e[type=item,limit=1,sort=nearest,tag=forSale,distance=..3]","objective":"count"},"color":"white"},{"text":"x ","color":"white"},{"selector":"@e[type=item,limit=1,sort=nearest,tag=forSale,distance=..3]"},{"text":" for ","color":"gray"},{"score":{"name":"@e[type=item,limit=1,sort=nearest,tag=forSale,distance=..3]","objective":"sellValue"},"color":"white"},{"text":"\u0001","color":"white"},{"text":" You have: ","color":"gray"},{"score":{"name":"@s","objective":"ss.diamondcount"},"color":"green"},{"text":"\u0001","color":"white"}]

execute as @a unless entity @s[scores={ss.playerid=-2147483648..2147483647}] run scoreboard players add ss.IDmaker dummy 1
execute as @a unless entity @s[scores={ss.playerid=-2147483648..2147483647}] run scoreboard players operation @s ss.playerid = ss.IDmaker dummy

execute as @e[tag=forSale] at @s if block ~ ~-1 ~ hopper run setblock ~ ~-1 ~ air destroy
execute as @e[tag=forSale] at @s if entity @e[type=hopper_minecart,dy=-2] as @e[type=hopper_minecart,dy=-2] run damage @s 100000
execute as @e[tag=forSale] at @s unless block ~ ~ ~ air run setblock ~ ~ ~ air destroy

execute as @e[tag=bought] at @s if block ~ ~-1 ~ hopper run setblock ~ ~-1 ~ air destroy
execute as @e[tag=bought] at @s if entity @e[type=hopper_minecart,dy=-2] as @e[type=hopper_minecart,dy=-2] run damage @s 100000
execute as @e[tag=bought] at @s unless block ~ ~ ~ air run setblock ~ ~ ~ air destroy

execute as @e[tag=forSale] at @s if entity @e[distance=..1,nbt={Item:{id:"minecraft:glass"}}] unless entity @e[tag=glassCase,distance=..0.6] run tag @s add isBeingCased
execute as @e[tag=forSale,tag=isBeingCased] at @s run kill @e[distance=..1,nbt={Item:{id:"minecraft:glass"}},limit=1,sort=nearest]
execute as @e[tag=forSale,tag=isBeingCased] at @s run summon block_display ~-0.375 ~ ~-0.375 {Tags:["glassCase"],block_state:{Name:"minecraft:glass",Properties:{}},transformation:[0.7500f,0.0000f,0.0000f,0.0000f,0.0000f,0.7500f,0.0000f,0.0000f,0.0000f,0.0000f,0.7500f,0.0000f,0.0000f,0.0000f,0.0000f,1.0000f]}
execute as @e[tag=forSale,tag=isBeingCased] at @s run playsound block.glass.place block @p ~ ~ ~ 0.5
tag @e[tag=forSale] remove isBeingCased

execute as @e[tag=forSale] at @s if entity @a[distance=..5] unless score noShulkerDisplay gamerule matches 1 run function ss:optional/shulker

scoreboard players reset @a isSneaking